package eu.ztsh.wymiana.validation;

import jakarta.validation.ConstraintValidator;
import jakarta.validation.ConstraintValidatorContext;
import org.assertj.core.api.AbstractBooleanAssert;
import org.hibernate.validator.internal.engine.DefaultClockProvider;
import org.junit.jupiter.api.BeforeAll;
import org.mockito.Mockito;

import static org.assertj.core.api.Assertions.assertThat;

public abstract class ValidatorTest<V extends ConstraintValidator<?, C>, C> {

    private final V validator;
    private static ConstraintValidatorContext validatorContext;

    protected ValidatorTest(V validator) {
        this.validator = validator;
    }

    @BeforeAll
    static void prepare() {
        validatorContext = Mockito.mock(ConstraintValidatorContext.class);
        Mockito.when(validatorContext.getClockProvider()).thenReturn(DefaultClockProvider.INSTANCE);
    }

    protected AbstractBooleanAssert<?> assertThatValidation(C value) {
        return assertThat(validator.isValid(value, validatorContext));
    }

}
